#!/usr/bin/env python
#-*- encoding:utf-8 -*-

import os
import sys

def is_normal_font(font_path):
	font=os.path.basename(font_path)
	result = []
	with open('/usr/bin/puafont/normalfont.txt') as f:
    		lines = f.readlines()
    		for line in lines:
        		result.append(line.strip('\n\r'))
			#result=list(set(result))
   	 	#print(result)
	if font in result:
		return True
	else:
		return False

def fc_list():
    ret = os.popen('fc-list').read()
    lines = ret.split('\n')[:-1]
    fonts = [line.split(':')[-3] for line in lines]  #huk   -2 -> -3
    return fonts

def font_check_upa(font):
    #这里用fc-query，主要是当前只做检查，而不做分析
    #如果需要分析，更准确的做法是用fc-scan, 对每种字体family有更详细信息
    #print (font)
    if is_normal_font(font):
	print('%s is normal font,skip check!' % font)
        return False
    ret = os.popen('fc-query %s' % font).read()
    #Private User Area: U+E00 - U+F8FF, U+F0000 - U+FFFFD, U+100000 = U+10FFFD, 其中第三个暂不考虑
    puas = [[0xe0, 0xf8], [0xf00, 0xfff]]
    for pua in puas:
        for segment in range(pua[0], pua[1]+1):
            charset_segment = '\n\t%04x: '%segment
            if charset_segment in ret:
                #如果需要，可做详细分析，看有那些自定义字符
                #这里不考虑，是因为直接更清楚
                return True
    return False

if __name__ == '__main__':
    fonts = fc_list()
    abnormals = 0
    for font in fonts:
        if font_check_upa(font):
            print('font file %s has private user area' % font)
            os.popen('test -d /tmp/test_font || mkdir  /tmp/test_font')
            os.popen('mv %s /tmp/test_font' % font)   # huk  删除这些待PUA的字体
            abnormals += 1
        else:
            pass
            #print('font file %s has no private user area' % font)
    print('System has totally %d fonts have private user area!' % abnormals)
    os.popen('systemctl disable pua-del.service')



